/*
 * Copyright (c) 2018-2019 Peter Bigot Consulting, LLC
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#ifndef APPLICATION_UART_SENSOR_H_
#define APPLICATION_UART_SENSOR_H_


// Variable Declaration
#include <inttypes.h>
#include <stddef.h>
#include <stdint.h>
#include <stdlib.h>                 // For Using "exit" function

#include <zephyr/device.h>
#include <zephyr/devicetree.h>
#include <zephyr/kernel.h>
#include <zephyr/sys/printk.h>
#include <zephyr/sys/util.h>
#include <zephyr/drivers/gpio.h>
	
// Include the header file of the UART driver in main.c
#include <zephyr/drivers/uart.h> // Uart 

// Include header files
#include "uart_sensor.h"


static uint8_t uart_value[4] = {0};
//static uint16_t distance = 0;  	// Distance

// V - Assigning the variable for receiving Uart sensor value
#define SLEEP_TIME_MS2   0 		// 1000 msec = 1 sec
#define RECEIVE_BUFF_SIZE 4		// Define the size of the receive buffer
static uint8_t rx_buf[RECEIVE_BUFF_SIZE] = {0};  // Define the receive buffer => V - buffer includes 4 members, and each member is 1 byte
#define RECEIVE_TIMEOUT 10 	// V - Define the receiving timeout period

static uint8_t comingData;     //V- This variable is set to 1 when there is Uart data coming

// Function Declarations
//static void uart_cb(const struct device *dev, struct uart_event *evt, void *user_data);
void uart_cb(const struct device *dev, struct uart_event *evt, void *user_data);
void initialize_uart_sensor(void);
uint8_t Enable_Read(void);          // V- When there is coming UART data, this function returns 1 for MAIN() function reading data
uint16_t read_distance(void);
#endif

